diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/tinymce/themes/advanced/editor_template_src.js /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/tinymce/themes/advanced/editor_template_src.js
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/tinymce/themes/advanced/editor_template_src.js	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/tinymce/themes/advanced/editor_template_src.js	2012-12-17 16:18:40.000000000 -0600
***************
*** 11,16 ****
--- 11,105 ----
  (function(tinymce) {
  	var DOM = tinymce.DOM, Event = tinymce.dom.Event, extend = tinymce.extend, each = tinymce.each, Cookie = tinymce.util.Cookie, lastExtID, explode = tinymce.explode;
  
+ 	// Generates a preview for a format
+ 	function getPreviewCss(ed, fmt) {
+ 		var name, previewElm, dom = ed.dom, previewCss = '', parentFontSize, previewStylesName;
+ 
+ 		previewStyles = ed.settings.preview_styles;
+ 
+ 		// No preview forced
+ 		if (previewStyles === false)
+ 			return '';
+ 
+ 		// Default preview
+ 		if (!previewStyles)
+ 			previewStyles = 'font-family font-size font-weight text-decoration text-transform color background-color';
+ 
+ 		// Removes any variables since these can't be previewed
+ 		function removeVars(val) {
+ 			return val.replace(/%(\w+)/g, '');
+ 		};
+ 
+ 		// Create block/inline element to use for preview
+ 		name = fmt.block || fmt.inline || 'span';
+ 		previewElm = dom.create(name);
+ 
+ 		// Add format styles to preview element
+ 		each(fmt.styles, function(value, name) {
+ 			value = removeVars(value);
+ 
+ 			if (value)
+ 				dom.setStyle(previewElm, name, value);
+ 		});
+ 
+ 		// Add attributes to preview element
+ 		each(fmt.attributes, function(value, name) {
+ 			value = removeVars(value);
+ 
+ 			if (value)
+ 				dom.setAttrib(previewElm, name, value);
+ 		});
+ 
+ 		// Add classes to preview element
+ 		each(fmt.classes, function(value) {
+ 			value = removeVars(value);
+ 
+ 			if (!dom.hasClass(previewElm, value))
+ 				dom.addClass(previewElm, value);
+ 		});
+ 
+ 		// Add the previewElm outside the visual area
+ 		dom.setStyles(previewElm, {position: 'absolute', left: -0xFFFF});
+ 		ed.getBody().appendChild(previewElm);
+ 
+ 		// Get parent container font size so we can compute px values out of em/% for older IE:s
+ 		parentFontSize = dom.getStyle(ed.getBody(), 'fontSize', true);
+ 		parentFontSize = /px$/.test(parentFontSize) ? parseInt(parentFontSize, 10) : 0;
+ 
+ 		each(previewStyles.split(' '), function(name) {
+ 			var value = dom.getStyle(previewElm, name, true);
+ 
+ 			// If background is transparent then check if the body has a background color we can use
+ 			if (name == 'background-color' && /transparent|rgba\s*\([^)]+,\s*0\)/.test(value)) {
+ 				value = dom.getStyle(ed.getBody(), name, true);
+ 
+ 				// Ignore white since it's the default color, not the nicest fix
+ 				if (dom.toHex(value).toLowerCase() == '#ffffff') {
+ 					return;
+ 				}
+ 			}
+ 
+ 			// Old IE won't calculate the font size so we need to do that manually
+ 			if (name == 'font-size') {
+ 				if (/em|%$/.test(value)) {
+ 					if (parentFontSize === 0) {
+ 						return;
+ 					}
+ 
+ 					// Convert font size from em/% to px
+ 					value = parseFloat(value, 10) / (/%$/.test(value) ? 100 : 1);
+ 					value = (value * parentFontSize) + 'px';
+ 				}
+ 			}
+ 
+ 			previewCss += name + ':' + value + ';';
+ 		});
+ 
+ 		dom.remove(previewElm);
+ 
+ 		return previewCss;
+ 	};
+ 
  	// Tell it to load theme specific language pack(s)
  	tinymce.ThemeManager.requireLangPack('advanced');
  
***************
*** 61,83 ****
  
  		init : function(ed, url) {
  			var t = this, s, v, o;
! 	
  			t.editor = ed;
  			t.url = url;
  			t.onResolveName = new tinymce.util.Dispatcher(this);
  
  			ed.forcedHighContrastMode = ed.settings.detect_highcontrast && t._isHighContrast();
  			ed.settings.skin = ed.forcedHighContrastMode ? 'highcontrast' : ed.settings.skin;
  
  			// Default settings
  			t.settings = s = extend({
  				theme_advanced_path : true,
! 				theme_advanced_toolbar_location : 'bottom',
! 				theme_advanced_buttons1 : "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect",
! 				theme_advanced_buttons2 : "bullist,numlist,|,outdent,indent,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code",
! 				theme_advanced_buttons3 : "hr,removeformat,visualaid,|,sub,sup,|,charmap",
  				theme_advanced_blockformats : "p,address,pre,h1,h2,h3,h4,h5,h6",
! 				theme_advanced_toolbar_align : "center",
  				theme_advanced_fonts : "Andale Mono=andale mono,times;Arial=arial,helvetica,sans-serif;Arial Black=arial black,avant garde;Book Antiqua=book antiqua,palatino;Comic Sans MS=comic sans ms,sans-serif;Courier New=courier new,courier;Georgia=georgia,palatino;Helvetica=helvetica;Impact=impact,chicago;Symbol=symbol;Tahoma=tahoma,arial,helvetica,sans-serif;Terminal=terminal,monaco;Times New Roman=times new roman,times;Trebuchet MS=trebuchet ms,geneva;Verdana=verdana,geneva;Webdings=webdings;Wingdings=wingdings,zapf dingbats",
  				theme_advanced_more_colors : 1,
  				theme_advanced_row_height : 23,
--- 150,180 ----
  
  		init : function(ed, url) {
  			var t = this, s, v, o;
! 
  			t.editor = ed;
  			t.url = url;
  			t.onResolveName = new tinymce.util.Dispatcher(this);
+ 			s = ed.settings;
  
  			ed.forcedHighContrastMode = ed.settings.detect_highcontrast && t._isHighContrast();
  			ed.settings.skin = ed.forcedHighContrastMode ? 'highcontrast' : ed.settings.skin;
  
+ 			// Setup default buttons
+ 			if (!s.theme_advanced_buttons1) {
+ 				s = extend({
+ 					theme_advanced_buttons1 : "bold,italic,underline,strikethrough,|,justifyleft,justifycenter,justifyright,justifyfull,|,styleselect,formatselect",
+ 					theme_advanced_buttons2 : "bullist,numlist,|,outdent,indent,|,undo,redo,|,link,unlink,anchor,image,cleanup,help,code",
+ 					theme_advanced_buttons3 : "hr,removeformat,visualaid,|,sub,sup,|,charmap"
+ 				}, s);
+ 			}
+ 
  			// Default settings
  			t.settings = s = extend({
  				theme_advanced_path : true,
! 				theme_advanced_toolbar_location : 'top',
  				theme_advanced_blockformats : "p,address,pre,h1,h2,h3,h4,h5,h6",
! 				theme_advanced_toolbar_align : "left",
! 				theme_advanced_statusbar_location : "bottom",
  				theme_advanced_fonts : "Andale Mono=andale mono,times;Arial=arial,helvetica,sans-serif;Arial Black=arial black,avant garde;Book Antiqua=book antiqua,palatino;Comic Sans MS=comic sans ms,sans-serif;Courier New=courier new,courier;Georgia=georgia,palatino;Helvetica=helvetica;Impact=impact,chicago;Symbol=symbol;Tahoma=tahoma,arial,helvetica,sans-serif;Terminal=terminal,monaco;Times New Roman=times new roman,times;Trebuchet MS=trebuchet ms,geneva;Verdana=verdana,geneva;Webdings=webdings;Wingdings=wingdings,zapf dingbats",
  				theme_advanced_more_colors : 1,
  				theme_advanced_row_height : 23,
***************
*** 87,93 ****
  				theme_advanced_font_selector : "span",
  				theme_advanced_show_current_color: 0,
  				readonly : ed.settings.readonly
! 			}, ed.settings);
  
  			// Setup default font_size_style_values
  			if (!s.font_size_style_values)
--- 184,190 ----
  				theme_advanced_font_selector : "span",
  				theme_advanced_show_current_color: 0,
  				readonly : ed.settings.readonly
! 			}, s);
  
  			// Setup default font_size_style_values
  			if (!s.font_size_style_values)
***************
*** 219,233 ****
  
  			if (ctrl.getLength() == 0) {
  				each(ed.dom.getClasses(), function(o, idx) {
! 					var name = 'style_' + idx;
  
! 					ed.formatter.register(name, {
  						inline : 'span',
  						attributes : {'class' : o['class']},
  						selector : '*'
! 					});
  
! 					ctrl.add(o['class'], name);
  				});
  			}
  		},
--- 316,336 ----
  
  			if (ctrl.getLength() == 0) {
  				each(ed.dom.getClasses(), function(o, idx) {
! 					var name = 'style_' + idx, fmt;
  
! 					fmt = {
  						inline : 'span',
  						attributes : {'class' : o['class']},
  						selector : '*'
! 					};
! 
! 					ed.formatter.register(name, fmt);
  
! 					ctrl.add(o['class'], name, {
! 						style: function() {
! 							return getPreviewCss(ed, fmt);
! 						}
! 					});
  				});
  			}
  		},
***************
*** 239,245 ****
  			ctrl = ctrlMan.createListBox('styleselect', {
  				title : 'advanced.style_select',
  				onselect : function(name) {
! 					var matches, formatNames = [];
  
  					each(ctrl.items, function(item) {
  						formatNames.push(item.value);
--- 342,348 ----
  			ctrl = ctrlMan.createListBox('styleselect', {
  				title : 'advanced.style_select',
  				onselect : function(name) {
! 					var matches, formatNames = [], removedFormat;
  
  					each(ctrl.items, function(item) {
  						formatNames.push(item.value);
***************
*** 248,259 ****
  					ed.focus();
  					ed.undoManager.add();
  
! 					// Toggle off the current format
  					matches = ed.formatter.matchAll(formatNames);
! 					if (!name || matches[0] == name) {
! 						if (matches[0]) 
! 							ed.formatter.remove(matches[0]);
! 					} else
  						ed.formatter.apply(name);
  
  					ed.undoManager.add();
--- 351,368 ----
  					ed.focus();
  					ed.undoManager.add();
  
! 					// Toggle off the current format(s)
  					matches = ed.formatter.matchAll(formatNames);
! 					tinymce.each(matches, function(match) {
! 						if (!name || match == name) {
! 							if (match)
! 								ed.formatter.remove(match);
! 
! 							removedFormat = true;
! 						}
! 					});
! 
! 					if (!removedFormat)
  						ed.formatter.apply(name);
  
  					ed.undoManager.add();
***************
*** 264,270 ****
  			});
  
  			// Handle specified format
! 			ed.onInit.add(function() {
  				var counter = 0, formats = ed.getParam('style_formats');
  
  				if (formats) {
--- 373,379 ----
  			});
  
  			// Handle specified format
! 			ed.onPreInit.add(function() {
  				var counter = 0, formats = ed.getParam('style_formats');
  
  				if (formats) {
***************
*** 276,299 ****
  						if (keys > 1) {
  							name = fmt.name = fmt.name || 'style_' + (counter++);
  							ed.formatter.register(name, fmt);
! 							ctrl.add(fmt.title, name);
  						} else
  							ctrl.add(fmt.title);
  					});
  				} else {
  					each(ed.getParam('theme_advanced_styles', '', 'hash'), function(val, key) {
! 						var name;
  
  						if (val) {
  							name = 'style_' + (counter++);
! 
! 							ed.formatter.register(name, {
  								inline : 'span',
  								classes : val,
  								selector : '*'
! 							});
  
! 							ctrl.add(t.editor.translate(key), name);
  						}
  					});
  				}
--- 385,416 ----
  						if (keys > 1) {
  							name = fmt.name = fmt.name || 'style_' + (counter++);
  							ed.formatter.register(name, fmt);
! 							ctrl.add(fmt.title, name, {
! 								style: function() {
! 									return getPreviewCss(ed, fmt);
! 								}
! 							});
  						} else
  							ctrl.add(fmt.title);
  					});
  				} else {
  					each(ed.getParam('theme_advanced_styles', '', 'hash'), function(val, key) {
! 						var name, fmt;
  
  						if (val) {
  							name = 'style_' + (counter++);
! 							fmt = {
  								inline : 'span',
  								classes : val,
  								selector : '*'
! 							};
  
! 							ed.formatter.register(name, fmt);
! 							ctrl.add(t.editor.translate(key), name, {
! 								style: function() {
! 									return getPreviewCss(ed, fmt);
! 								}
! 							});
  						}
  					});
  				}
***************
*** 433,439 ****
  
  			if (c) {
  				each(t.editor.getParam('theme_advanced_blockformats', t.settings.theme_advanced_blockformats, 'hash'), function(v, k) {
! 					c.add(t.editor.translate(k != v ? k : fmts[v]), v, {'class' : 'mce_formatPreview mce_' + v});
  				});
  			}
  
--- 550,558 ----
  
  			if (c) {
  				each(t.editor.getParam('theme_advanced_blockformats', t.settings.theme_advanced_blockformats, 'hash'), function(v, k) {
! 					c.add(t.editor.translate(k != v ? k : fmts[v]), v, {'class' : 'mce_formatPreview mce_' + v, style: function() {
! 						return getPreviewCss(t.editor, {block: v});
! 					}});
  				});
  			}
  
***************
*** 507,513 ****
  
  			// TODO: ACC Should have an aria-describedby attribute which is user-configurable to describe what this field is actually for.
  			// Maybe actually inherit it from the original textara?
! 			n = p = DOM.create('span', {role : 'application', 'aria-labelledby' : ed.id + '_voice', id : ed.id + '_parent', 'class' : 'mceEditor ' + ed.settings.skin + 'Skin' + (s.skin_variant ? ' ' + ed.settings.skin + 'Skin' + t._ufirst(s.skin_variant) : '')});
  			DOM.add(n, 'span', {'class': 'mceVoiceLabel', 'style': 'display:none;', id: ed.id + '_voice'}, s.aria_label);
  
  			if (!DOM.boxModel)
--- 626,632 ----
  
  			// TODO: ACC Should have an aria-describedby attribute which is user-configurable to describe what this field is actually for.
  			// Maybe actually inherit it from the original textara?
! 			n = p = DOM.create('span', {role : 'application', 'aria-labelledby' : ed.id + '_voice', id : ed.id + '_parent', 'class' : 'mceEditor ' + ed.settings.skin + 'Skin' + (s.skin_variant ? ' ' + ed.settings.skin + 'Skin' + t._ufirst(s.skin_variant) : '') + (ed.settings.directionality == "rtl" ? ' mceRtl' : '')});
  			DOM.add(n, 'span', {'class': 'mceVoiceLabel', 'style': 'display:none;', id: ed.id + '_voice'}, s.aria_label);
  
  			if (!DOM.boxModel)
***************
*** 552,566 ****
  
  				if (e.nodeName == 'A') {
  					t._sel(e.className.replace(/^.*mcePath_([0-9]+).*$/, '$1'));
! 
! 					return Event.cancel(e);
  				}
  			});
  /*
  			if (DOM.get(ed.id + '_path_row')) {
  				Event.add(ed.id + '_tbl', 'mouseover', function(e) {
  					var re;
! 	
  					e = e.target;
  
  					if (e.nodeName == 'SPAN' && DOM.hasClass(e.parentNode, 'mceButton')) {
--- 671,684 ----
  
  				if (e.nodeName == 'A') {
  					t._sel(e.className.replace(/^.*mcePath_([0-9]+).*$/, '$1'));
! 					return false;
  				}
  			});
  /*
  			if (DOM.get(ed.id + '_path_row')) {
  				Event.add(ed.id + '_tbl', 'mouseover', function(e) {
  					var re;
! 
  					e = e.target;
  
  					if (e.nodeName == 'SPAN' && DOM.hasClass(e.parentNode, 'mceButton')) {
***************
*** 713,718 ****
--- 831,837 ----
  					var f = Event.add(ed.id + '_external_close', 'click', function() {
  						DOM.hide(ed.id + '_external');
  						Event.remove(ed.id + '_external_close', 'click', f);
+ 						return false;
  					});
  
  					DOM.show(e);
***************
*** 825,831 ****
  		},
  
  		_addToolbars : function(c, o) {
! 			var t = this, i, tb, ed = t.editor, s = t.settings, v, cf = ed.controlManager, di, n, h = [], a, toolbarGroup;
  
  			toolbarGroup = cf.createToolbarGroup('toolbargroup', {
  				'name': ed.getLang('advanced.toolbar'),
--- 944,950 ----
  		},
  
  		_addToolbars : function(c, o) {
! 			var t = this, i, tb, ed = t.editor, s = t.settings, v, cf = ed.controlManager, di, n, h = [], a, toolbarGroup, toolbarsExist = false;
  
  			toolbarGroup = cf.createToolbarGroup('toolbargroup', {
  				'name': ed.getLang('advanced.toolbar'),
***************
*** 837,846 ****
  			a = s.theme_advanced_toolbar_align.toLowerCase();
  			a = 'mce' + t._ufirst(a);
  
! 			n = DOM.add(DOM.add(c, 'tr', {role: 'presentation'}), 'td', {'class' : 'mceToolbar ' + a, "role":"presentation"});
  
  			// Create toolbar and add the controls
  			for (i=1; (v = s['theme_advanced_buttons' + i]); i++) {
  				tb = cf.createToolbar("toolbar" + i, {'class' : 'mceToolbarRow' + i});
  
  				if (s['theme_advanced_buttons' + i + '_add'])
--- 956,966 ----
  			a = s.theme_advanced_toolbar_align.toLowerCase();
  			a = 'mce' + t._ufirst(a);
  
! 			n = DOM.add(DOM.add(c, 'tr', {role: 'presentation'}), 'td', {'class' : 'mceToolbar ' + a, "role":"toolbar"});
  
  			// Create toolbar and add the controls
  			for (i=1; (v = s['theme_advanced_buttons' + i]); i++) {
+ 				toolbarsExist = true;
  				tb = cf.createToolbar("toolbar" + i, {'class' : 'mceToolbarRow' + i});
  
  				if (s['theme_advanced_buttons' + i + '_add'])
***************
*** 854,859 ****
--- 974,982 ----
  
  				o.deltaHeight -= s.theme_advanced_row_height;
  			}
+ 			// Handle case when there are no toolbar buttons and ensure editor height is adjusted accordingly
+ 			if (!toolbarsExist)
+ 				o.deltaHeight -= s.theme_advanced_row_height;
  			h.push(toolbarGroup.renderHTML());
  			h.push(DOM.createHTML('a', {href : '#', accesskey : 'z', title : ed.getLang("advanced.toolbar_focus"), onfocus : 'tinyMCE.getInstanceById(\'' + ed.id + '\').focus();'}, '<!-- IE -->'));
  			DOM.setHTML(n, h.join(''));
***************
*** 863,869 ****
  			var n, t = this, ed = t.editor, s = t.settings, r, mf, me, td;
  
  			n = DOM.add(tb, 'tr');
! 			n = td = DOM.add(n, 'td', {'class' : 'mceStatusbar'}); 
  			n = DOM.add(n, 'div', {id : ed.id + '_path_row', 'role': 'group', 'aria-labelledby': ed.id + '_path_voice'});
  			if (s.theme_advanced_path) {
  				DOM.add(n, 'span', {id: ed.id + '_path_voice'}, ed.translate('advanced.path'));
--- 986,992 ----
  			var n, t = this, ed = t.editor, s = t.settings, r, mf, me, td;
  
  			n = DOM.add(tb, 'tr');
! 			n = td = DOM.add(n, 'td', {'class' : 'mceStatusbar'});
  			n = DOM.add(n, 'div', {id : ed.id + '_path_row', 'role': 'group', 'aria-labelledby': ed.id + '_path_voice'});
  			if (s.theme_advanced_path) {
  				DOM.add(n, 'span', {id: ed.id + '_path_voice'}, ed.translate('advanced.path'));
***************
*** 871,877 ****
  			} else {
  				DOM.add(n, 'span', {}, '&#160;');
  			}
! 			
  
  			if (s.theme_advanced_resizing) {
  				DOM.add(td, 'a', {id : ed.id + '_resize', href : 'javascript:;', onclick : "return false;", 'class' : 'mceResize', tabIndex:"-1"});
--- 994,1000 ----
  			} else {
  				DOM.add(n, 'span', {}, '&#160;');
  			}
! 
  
  			if (s.theme_advanced_resizing) {
  				DOM.add(td, 'a', {id : ed.id + '_resize', href : 'javascript:;', onclick : "return false;", 'class' : 'mceResize', tabIndex:"-1"});
***************
*** 916,921 ****
--- 1039,1046 ----
  							width = startWidth + (e.screenX - startX);
  							height = startHeight + (e.screenY - startY);
  							t.resizeTo(width, height, true);
+ 
+ 							ed.nodeChanged();
  						};
  
  						e.preventDefault();
***************
*** 975,993 ****
  
  			p = getParent('A');
  			if (c = cm.get('link')) {
! 				if (!p || !p.name) {
! 					c.setDisabled(!p && co);
! 					c.setActive(!!p);
! 				}
  			}
  
  			if (c = cm.get('unlink')) {
  				c.setDisabled(!p && co);
! 				c.setActive(!!p && !p.name);
  			}
  
  			if (c = cm.get('anchor')) {
! 				c.setActive(!co && !!p && p.name);
  			}
  
  			p = getParent('IMG');
--- 1100,1116 ----
  
  			p = getParent('A');
  			if (c = cm.get('link')) {
! 				c.setDisabled((!p && co) || (p && !p.href));
! 				c.setActive(!!p && (!p.name && !p.id));
  			}
  
  			if (c = cm.get('unlink')) {
  				c.setDisabled(!p && co);
! 				c.setActive(!!p && !p.name && !p.id);
  			}
  
  			if (c = cm.get('anchor')) {
! 				c.setActive(!co && !!p && (p.name || (p.id && !p.href)));
  			}
  
  			p = getParent('IMG');
***************
*** 1004,1013 ****
  
  				matches = ed.formatter.matchAll(formatNames);
  				c.select(matches[0]);
  			}
  
  			if (c = cm.get('formatselect')) {
! 				p = getParent(DOM.isBlock);
  
  				if (p)
  					c.select(p.nodeName.toLowerCase());
--- 1127,1141 ----
  
  				matches = ed.formatter.matchAll(formatNames);
  				c.select(matches[0]);
+ 				tinymce.each(matches, function(match, index) {
+ 					if (index > 0) {
+ 						c.mark(match);
+ 					}
+ 				});
  			}
  
  			if (c = cm.get('formatselect')) {
! 				p = getParent(ed.dom.isBlock);
  
  				if (p)
  					c.select(p.nodeName.toLowerCase());
***************
*** 1026,1032 ****
  
  					if (!fn && n.style.fontFamily)
  						fn = n.style.fontFamily.replace(/[\"\']+/g, '').replace(/^([^,]+).*/, '$1').toLowerCase();
! 					
  					if (!fc && n.style.color)
  						fc = n.style.color;
  
--- 1154,1160 ----
  
  					if (!fn && n.style.fontFamily)
  						fn = n.style.fontFamily.replace(/[\"\']+/g, '').replace(/^([^,]+).*/, '$1').toLowerCase();
! 
  					if (!fc && n.style.color)
  						fc = n.style.color;
  
***************
*** 1057,1063 ****
  						return true;
  				});
  			}
! 			
  			if (s.theme_advanced_show_current_color) {
  				function updateColor(controlId, color) {
  					if (c = cm.get(controlId)) {
--- 1185,1191 ----
  						return true;
  				});
  			}
! 
  			if (s.theme_advanced_show_current_color) {
  				function updateColor(controlId, color) {
  					if (c = cm.get(controlId)) {
***************
*** 1105,1111 ****
  						return;
  
  					// Handle prefix
! 					if (tinymce.isIE && n.scopeName !== 'HTML')
  						na = n.scopeName + ':' + na;
  
  					// Remove internal prefix
--- 1233,1239 ----
  						return;
  
  					// Handle prefix
! 					if (tinymce.isIE && n.scopeName !== 'HTML' && n.scopeName)
  						na = n.scopeName + ':' + na;
  
  					// Remove internal prefix
***************
*** 1161,1172 ****
  						ti += 'id: ' + v + ' ';
  
  					if (v = n.className) {
! 						v = v.replace(/\b\s*(webkit|mce|Apple-)\w+\s*\b/g, '')
  
  						if (v) {
  							ti += 'class: ' + v + ' ';
  
! 							if (DOM.isBlock(n) || na == 'img' || na == 'span')
  								na += '.' + v;
  						}
  					}
--- 1289,1300 ----
  						ti += 'id: ' + v + ' ';
  
  					if (v = n.className) {
! 						v = v.replace(/\b\s*(webkit|mce|Apple-)\w+\s*\b/g, '');
  
  						if (v) {
  							ti += 'class: ' + v + ' ';
  
! 							if (ed.dom.isBlock(n) || na == 'img' || na == 'span')
  								na += '.' + v;
  						}
  					}
***************
*** 1294,1300 ****
  			var ed = this.editor;
  
  			// Internal image object like a flash placeholder
! 			if (ed.dom.getAttrib(ed.selection.getNode(), 'class').indexOf('mceItem') != -1)
  				return;
  
  			ed.windowManager.open({
--- 1422,1428 ----
  			var ed = this.editor;
  
  			// Internal image object like a flash placeholder
! 			if (ed.dom.getAttrib(ed.selection.getNode(), 'class', '').indexOf('mceItem') != -1)
  				return;
  
  			ed.windowManager.open({
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/tinymce/themes/advanced/js/anchor.js /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/tinymce/themes/advanced/js/anchor.js
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/tinymce/themes/advanced/js/anchor.js	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/tinymce/themes/advanced/js/anchor.js	2012-12-17 16:18:40.000000000 -0600
***************
*** 6,12 ****
  
  		this.editor = ed;
  		elm = ed.dom.getParent(ed.selection.getNode(), 'A');
! 		v = ed.dom.getAttrib(elm, 'name');
  
  		if (v) {
  			this.action = 'update';
--- 6,12 ----
  
  		this.editor = ed;
  		elm = ed.dom.getParent(ed.selection.getNode(), 'A');
! 		v = ed.dom.getAttrib(elm, 'name') || ed.dom.getAttrib(elm, 'id');
  
  		if (v) {
  			this.action = 'update';
***************
*** 17,23 ****
  	},
  
  	update : function() {
! 		var ed = this.editor, elm, name = document.forms[0].anchorName.value;
  
  		if (!name || !/^[a-z][a-z0-9\-\_:\.]*$/i.test(name)) {
  			tinyMCEPopup.alert('advanced_dlg.anchor_invalid');
--- 17,23 ----
  	},
  
  	update : function() {
! 		var ed = this.editor, elm, name = document.forms[0].anchorName.value, attribName;
  
  		if (!name || !/^[a-z][a-z0-9\-\_:\.]*$/i.test(name)) {
  			tinyMCEPopup.alert('advanced_dlg.anchor_invalid');
***************
*** 29,40 ****
  		if (this.action != 'update')
  			ed.selection.collapse(1);
  
  		elm = ed.dom.getParent(ed.selection.getNode(), 'A');
  		if (elm) {
! 			elm.setAttribute('name', name);
! 			elm.name = name;
! 		} else
! 			ed.execCommand('mceInsertContent', 0, ed.dom.createHTML('a', {name : name, 'class' : 'mceItemAnchor'}, ''));
  
  		tinyMCEPopup.close();
  	}
--- 29,53 ----
  		if (this.action != 'update')
  			ed.selection.collapse(1);
  
+ 		var aRule = ed.schema.getElementRule('a');
+ 		if (!aRule || aRule.attributes.name) {
+ 			attribName = 'name';
+ 		} else {
+ 			attribName = 'id';
+ 		}
+ 
  		elm = ed.dom.getParent(ed.selection.getNode(), 'A');
  		if (elm) {
! 			elm.setAttribute(attribName, name);
! 			elm[attribName] = name;
! 			ed.undoManager.add();
! 		} else {
! 			// create with zero-sized nbsp so that in Webkit where anchor is on last line by itself caret cannot be placed after it
! 			var attrs =  {'class' : 'mceItemAnchor'};
! 			attrs[attribName] = name;
! 			ed.execCommand('mceInsertContent', 0, ed.dom.createHTML('a', attrs, '\uFEFF'));
! 			ed.nodeChanged();
! 		}
  
  		tinyMCEPopup.close();
  	}
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/tinymce/themes/advanced/js/color_picker.js /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/tinymce/themes/advanced/js/color_picker.js
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/tinymce/themes/advanced/js/color_picker.js	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/tinymce/themes/advanced/js/color_picker.js	2012-12-17 16:18:40.000000000 -0600
***************
*** 77,83 ****
  		if (col)
  			updateLight(col.r, col.g, col.b);
  	}
! 	
  	for (key in named) {
  		value = named[key];
  		namedLookup[value.replace(/\s+/, '').toLowerCase()] = key.replace(/#/, '').toLowerCase();
--- 77,83 ----
  		if (col)
  			updateLight(col.r, col.g, col.b);
  	}
! 
  	for (key in named) {
  		value = named[key];
  		namedLookup[value.replace(/\s+/, '').toLowerCase()] = key.replace(/#/, '').toLowerCase();
***************
*** 93,132 ****
  		return value.length > 1 ? value : '0' + value; // Padd with leading zero
  	};
  
! 	color = color.replace(/[\s#]+/g, '').toLowerCase();
  	color = namedLookup[color] || color;
! 	matches = /^rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)|([a-f0-9]{2})([a-f0-9]{2})([a-f0-9]{2})|([a-f0-9])([a-f0-9])([a-f0-9])$/.exec(color);
  
  	if (matches) {
! 		if (matches[1]) {
! 			red = toInt(matches[1]);
! 			green = toInt(matches[2]);
! 			blue = toInt(matches[3]);
! 		} else if (matches[4]) {
! 			red = toInt(matches[4], 16);
! 			green = toInt(matches[5], 16);
! 			blue = toInt(matches[6], 16);
! 		} else if (matches[7]) {
! 			red = toInt(matches[7] + matches[7], 16);
! 			green = toInt(matches[8] + matches[8], 16);
! 			blue = toInt(matches[9] + matches[9], 16);
! 		}
  
! 		return '#' + hex(red) + hex(green) + hex(blue);
  	}
  
! 	return '';
  }
  
  function insertAction() {
  	var color = document.getElementById("color").value, f = tinyMCEPopup.getWindowArg('func');
  
! 	tinyMCEPopup.restoreSelection();
  
! 	if (f)
! 		f(toHexColor(color));
  
! 	tinyMCEPopup.close();
  }
  
  function showColor(color, name) {
--- 93,148 ----
  		return value.length > 1 ? value : '0' + value; // Padd with leading zero
  	};
  
! 	color = tinymce.trim(color);
! 	color = color.replace(/^[#]/, '').toLowerCase();  // remove leading '#'
  	color = namedLookup[color] || color;
! 
! 	matches = /^rgb\((\d{1,3}),(\d{1,3}),(\d{1,3})\)$/.exec(color);
  
  	if (matches) {
! 		red   = toInt(matches[1]);
! 		green = toInt(matches[2]);
! 		blue  = toInt(matches[3]);
! 	} else {
! 		matches = /^([0-9a-f]{2})([0-9a-f]{2})([0-9a-f]{2})$/.exec(color);
! 
! 		if (matches) {
! 			red   = toInt(matches[1], 16);
! 			green = toInt(matches[2], 16);
! 			blue  = toInt(matches[3], 16);
! 		} else {
! 			matches = /^([0-9a-f])([0-9a-f])([0-9a-f])$/.exec(color);
  
! 			if (matches) {
! 				red   = toInt(matches[1] + matches[1], 16);
! 				green = toInt(matches[2] + matches[2], 16);
! 				blue  = toInt(matches[3] + matches[3], 16);
! 			} else {
! 				return '';
! 			}
! 		}
  	}
  
! 	return '#' + hex(red) + hex(green) + hex(blue);
  }
  
  function insertAction() {
  	var color = document.getElementById("color").value, f = tinyMCEPopup.getWindowArg('func');
  
! 	var hexColor = toHexColor(color);
! 
! 	if (hexColor === '') {
! 		var text = tinyMCEPopup.editor.getLang('advanced_dlg.invalid_color_value');
! 		tinyMCEPopup.alert(text + ': ' + color);
! 	}
! 	else {
! 		tinyMCEPopup.restoreSelection();
  
! 		if (f)
! 			f(hexColor);
  
! 		tinyMCEPopup.close();
! 	}
  }
  
  function showColor(color, name) {
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/tinymce/themes/advanced/js/image.js /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/tinymce/themes/advanced/js/image.js
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-includes/js/tinymce/themes/advanced/js/image.js	2012-10-29 12:35:29.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-includes/js/tinymce/themes/advanced/js/image.js	2012-12-17 16:18:40.000000000 -0600
***************
*** 104,113 ****
  	},
  
  	updateStyle : function() {
! 		var dom = tinyMCEPopup.dom, st, v, f = document.forms[0];
  
  		if (tinyMCEPopup.editor.settings.inline_styles) {
! 			st = tinyMCEPopup.dom.parseStyle(this.styleVal);
  
  			// Handle align
  			v = getSelectValue(f, 'align');
--- 104,115 ----
  	},
  
  	updateStyle : function() {
! 		var dom = tinyMCEPopup.dom, st = {}, v, f = document.forms[0];
  
  		if (tinyMCEPopup.editor.settings.inline_styles) {
! 			tinymce.each(tinyMCEPopup.dom.parseStyle(this.styleVal), function(value, key) {
! 				st[key] = value;
! 			});
  
  			// Handle align
  			v = getSelectValue(f, 'align');
